#****************************************************************************
#**
#**  File     :  /cdimage/units/XRB2336/XRB2336_script.lua
#**  Author(s):  David Tomandl
#**
#**  Summary  :  Cybran Long Range Radar Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local CRadarUnit = import('/lua/cybranunits.lua').CRadarUnit
local StunZapperWeapon = import('/mods/BlackOps/lua/BlackOpsweapons.lua').StunZapperWeapon

XRB2336 = Class(CRadarUnit) { 

    Weapons = {
        Turret01 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere01')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.55)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere01',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
        Turret02 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere02')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.5)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere02',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
        Turret03 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere03')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.5)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere03',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
        Turret04 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere04')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.5)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere04',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
        Turret05 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere05')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.5)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere05',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
        Turret06 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere06')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.5)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere06',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
        Turret07 = Class(StunZapperWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/mods/BlackOps/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                StunZapperWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'Sphere07')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.5)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'Sphere07',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (StunZapperWeapon.IdleState) {
                Main = function(self)
                    StunZapperWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    StunZapperWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                StunZapperWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,
        },
    }, 


}
TypeClass = XRB2336